# Maps for TFM
library(matrixStats)
#-------------------------------------------------------------------------------

model_corrected <- UK_total_df
length_data     <- length(model_corrected)
n_points_model  <- length(model_corrected[[1]])

if(pollutant=="no2"){
  n_max <- 19
  length_days <- length_data/24
} else if (pollutant=="pm10" | pollutant=="pm2p5"){
  n_max <- 36
  length_days <- length_data
}

pollutant_matrix <- matrix(data=NA, nrow=n_points_model,ncol = length_data )


for(h in 1:length_data) {
  pollutant_matrix[,h] <-  model_corrected[[h]]
}

if(pollutant=="o3"){
  # ANNUAL MEAN
  annual_mean                      <- rowMeans(pollutant_matrix, na.rm = TRUE)
  df_annual_mean                   <- data.frame(data=annual_mean, lon=lon_model, lat=lat_model)
  coordinates(df_annual_mean)      <- ~lon+lat
  sp::proj4string(df_annual_mean)  <- crs_latlon
  
  # OCTOHORARI
  media_octohoraria_mean  <- matrix(NA, nrow = n_points_model, ncol = 17)
  media_octohoraria_max   <- matrix(NA, nrow = n_points_model, ncol = length_days)
  annual_26_max <- matrix(NA,nrow=n_points_model, ncol=1)
  
  for (i in 1:length_days) {
    inicio                   <- (i - 1) * 24 + 1
    fin                      <- i * 24
    bloques_24h              <- pollutant_matrix[,inicio:fin]
    
    for(o in 1:17){
      start    <- o
      end      <- o+7
      bloque_8h                  <- bloques_24h[,start:end]
      mean_8h                    <- apply(bloque_8h, 1, mean, na.rm = TRUE)
      media_octohoraria_mean[,o] <- mean_8h
    }
    media_octohoraria_max [,i]<- rowMaxs(media_octohoraria_mean, na.rm = TRUE)
  }
  annual_26_max <- sort(media_octohoraria_max, decreasing = TRUE)[26] #revisar si funciona aquesta linea
}


if (pollutant!="o3"){
  # ANNUAL MEAN
  annual_mean                      <- rowMeans(pollutant_matrix, na.rm = TRUE)
  df_annual_mean                   <- data.frame(data=annual_mean, lon=lon_model, lat=lat_model)
  coordinates(df_annual_mean)      <- ~lon+lat
  sp::proj4string(df_annual_mean)  <- crs_latlon
  
  if (compute_in_UTM) {
    df_annual_mean <- spTransform(df_annual_mean, sp::CRS(crs_utm))
  }
  
  
  # The n_max max value
  pollutant_sort              <- pollutant_matrix
  pollutant_max               <- base::rep(NA,n_points_model)
  
  if(pollutant=="pm10" | pollutant=="pm2p5"){
    for(i in 1:n_points_model){
      pollutant_sort[i,]=sort(pollutant_matrix[i,],na.last=TRUE,decreasing=TRUE)
      pollutant_max[i]=pollutant_sort[i,36]
    }
    
    df_pollutant_max                   <- data.frame(data=pollutant_max,lon=lon_model,lat=lat_model)
    coordinates(df_pollutant_max)      <- ~lon+lat
    sp::proj4string(df_pollutant_max)  <- crs_latlon
    
    if (compute_in_UTM) {
      df_pollutant_max <- spTransform(df_pollutant_max, sp::CRS(crs_utm))
    }
  } else if(pollutant=="no2"){
    
    #Replantejament 19 è max
    #pollutant_day         <- matrix(NA, nrow=n_points_model, ncol=24)
    pollutant_annual_max  <- matrix(NA, nrow=n_points_model, ncol=length_days)
    pollutant_19_max      <- matrix(NA, nrow=n_points_model, ncol=1)
    
    
    for (i in 1:length_days) {
      inicio                   <- (i - 1) * 24 + 1
      fin                      <- i * 24
      bloques_24h              <- pollutant_matrix[,inicio:fin]
      maximos                  <- apply(bloques_24h, 1, max, na.rm = TRUE)
      pollutant_annual_max[,i] <- maximos
    }
    
    for(n in 1:n_points_model){
      pollutant_19_max[n, ] <- sort(pollutant_annual_max[i, ], decreasing = TRUE)[19]
      
    }
    df_pollutant_19_max <- data.frame(data=pollutant_19_max, lon=lon_model, lat=lat_model)
    coordinates(df_pollutant_19_max) <- ~lon+lat
    sp::proj4string(df_pollutant_19_max)  <- crs_latlon
    
    if (compute_in_UTM) {
      df_pollutant_19_max <- spTransform(df_pollutant_19_max, sp::CRS(crs_utm))
    }
  }
  
  
}





# # Màx.
# 
# pollutant_max               <- base::rep(NA,n_points_model)
# 
# #màxim
# for(i in 1:n_points_model){
#   pollutant_max[i]=max(pollutant_matrix[i,],na.rm=TRUE) }
# 
# df_pollutant_max                   <- data.frame(data=pollutant_max,lon=lon_model, lat=lat_model)
# coordinates(df_pollutant_max)      <- ~lon+lat
# sp::proj4string(df_pollutant_max)  <- crs_latlon
# 
# if (compute_in_UTM) {
#   df_pollutant_max <- spTransform(df_pollutant_max, sp::CRS(crs_utm))
# }
# 
# # Transponer los datos
# data <- UK_total_df
# 
# # Obtener dimensiones de los datos transpuestos
# num_points <- length(data[[1]])
# num_hours <- length(data)
# 
# # Definir el número de días y calcular el número de bloques de 24 horas
# num_days <- num_hours %/% 24
# num_blocks <- num_days * 24
# 
# # Crear una matriz para almacenar los máximos diarios
# matriz_maximos <- matrix(0, nrow = num_points, ncol = num_days)
# 
# # Calcular los máximos diarios
# for (i in 1:num_days) {
#   inicio              <- (i - 1) * 24 + 1
#   fin                 <- i * 24
#   bloques_24h         <- data[inicio:fin]
#   maximos             <- apply(bloques_24h, 1, max)
#   matriz_maximos[, i] <- maximos
# }


